"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _os = require("os");

var _child_process = require("child_process");

var _debug = require("./debug");

var debug = _interopRequireWildcard(_debug);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _github = require("github");

var _github2 = _interopRequireDefault(_github);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Version = function () {
  (0, _createClass3.default)(Version, null, [{
    key: "exec",
    value: function exec(cmd) {
      var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      debug.info("Executing: " + cmd);

      // Execute command, split lines, & trim empty ones
      var output = (0, _child_process.execSync)(cmd, (0, _extends3.default)({
        env: process.env
      }, options)).toString();

      return output.split(_os.EOL).filter(Boolean);
    }
  }, {
    key: "getBranch",
    value: function getBranch() {
      var branch = process.env.BRANCH || process.env.CIRCLE_BRANCH || process.env.TRAVIS_BRANCH;

      if (branch) {
        return branch;
      }

      var headFile = _path2.default.join(process.cwd(), ".git", "HEAD");
      var headContents = _fs2.default.readFileSync(headFile, "utf8");

      var _ref = headContents.match(/ref: refs\/heads\/([^\n]+)/) || [];

      var _ref2 = (0, _slicedToArray3.default)(_ref, 2);

      var _ = _ref2[0];
      var name = _ref2[1];


      return name;
    }
  }, {
    key: "getCommitRange",
    value: function getCommitRange() {
      return [Version.getLatestTag() || Version.getInitialCommit(), "HEAD"].join("..");
    }
  }, {
    key: "getIncrement",
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var pr;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pr = Version.getLastPullRequest();

                if (pr) {
                  _context.next = 4;
                  break;
                }

                debug.warn("Only commits found. Defaulting to " + Version.INCREMENT_PATCH + ".");
                return _context.abrupt("return", Version.INCREMENT_PATCH);

              case 4:
                _context.next = 6;
                return Version.getIncrementFromPullRequest(pr);

              case 6:
                return _context.abrupt("return", _context.sent);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getIncrement() {
        return ref.apply(this, arguments);
      }

      return getIncrement;
    }()
  }, {
    key: "getIncrementFromPullRequest",
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(number) {
        var github, token, _Version$getUserRepo, user, repo;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                github = new _github2.default({
                  version: "3.0.0"
                });
                token = process.env.GH_TOKEN || process.env.GITHUB_TOKEN;


                if (token) {
                  github.authenticate({
                    token: token,
                    type: "oauth"
                  });
                }

                _Version$getUserRepo = Version.getUserRepo();
                user = _Version$getUserRepo.user;
                repo = _Version$getUserRepo.repo;
                return _context2.abrupt("return", new _promise2.default(function (resolve, reject) {
                  github.issues.getIssueLabels({ user: user, repo: repo, number: number }, function (err, labels) {
                    if (err) {
                      return reject(err);
                    }

                    if (!labels) {
                      debug.warn("No labels found on PR #" + number + ". Defaulting to " + Version.INCREMENT_PATCH + ".");

                      return resolve(Version.INCREMENT_PATCH);
                    }

                    var increment = labels.map(function (label) {
                      return label.name;
                    }).filter(function (name) {
                      return name.match(/^Version:/);
                    }).map(function (name) {
                      return name.split("Version: ").pop().toUpperCase();
                    }).map(function (increment) {
                      return Version["INCREMENT_" + increment];
                    }).shift();

                    if (increment) {
                      debug.info("Found " + increment + " label on PR #" + number + ".");
                      return resolve(increment);
                    }

                    debug.warn("No \"Version:\" labels found on PR #" + number + ". Defaulting to " + Version.INCREMENT_PATCH + ".");

                    return resolve(Version.INCREMENT_PATCH);
                  });
                }));

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getIncrementFromPullRequest(_x2) {
        return ref.apply(this, arguments);
      }

      return getIncrementFromPullRequest;
    }()
  }, {
    key: "getInitialCommit",
    value: function getInitialCommit() {
      return Version.exec("git log --format=%h --max-parents=0 HEAD").filter(Boolean).pop();
    }
  }, {
    key: "getLastPullRequest",
    value: function getLastPullRequest() {
      var range = Version.getCommitRange();
      var commit = Version.exec("git log --merges -n1 --format='%an|%ae|%s' " + range).shift();

      if (!commit) {
        debug.warn("No merge commits found between: %s", range);
        return null;
      }

      var _commit$split = commit.split("|");

      var _commit$split2 = (0, _slicedToArray3.default)(_commit$split, 3);

      var name = _commit$split2[0];
      var email = _commit$split2[1];
      var message = _commit$split2[2];


      if (!message) {
        return debug.error("Could not parse name, email, & message from: " + commit);
      }

      var _ref3 = message.match(/Merge pull request #(\d+)/) || [];

      var _ref4 = (0, _slicedToArray3.default)(_ref3, 2);

      var pr = _ref4[1];


      return pr;
    }
  }, {
    key: "getLatestTag",
    value: function getLatestTag() {
      var tag = Version.exec("git fetch --tags && git tag -l v*").filter(function (tag) {
        return tag.match(/^v(\d+)\.(\d+)\.(\d)/);
      }).pop();

      if (tag) {
        debug.info("Latest tag: %s", tag);
      } else {
        debug.warn("No tags found!");
      }

      return tag || null;
    }
  }, {
    key: "getUserRepo",
    value: function getUserRepo() {
      var _Version$exec$shift$r = Version.exec("git config --get remote.origin.url").shift().replace(".git", "").split(/\/|:/).slice(-2);

      var _Version$exec$shift$r2 = (0, _slicedToArray3.default)(_Version$exec$shift$r, 2);

      var user = _Version$exec$shift$r2[0];
      var repo = _Version$exec$shift$r2[1];


      debug.info("User: %s", user);
      debug.info("Repo: %s", repo);

      return { user: user, repo: repo };
    }
  }]);

  function Version(pkg, options) {
    (0, _classCallCheck3.default)(this, Version);

    this.pkg = pkg;
    this.options = (0, _extends3.default)({}, Version.defaultOptions, options);

    // Force dry-run when not on the release branch
    if (Version.getBranch() !== this.options.branch) {
      this.options.dryRun = true;
    }

    debug.info("Current branch: %s", Version.getBranch());
    debug.info("Release branch: %s", this.options.branch);

    if (this.options.dryRun) {
      debug.info("Dry-run enabled");
    }
  }

  (0, _createClass3.default)(Version, [{
    key: "increment",
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
        var increment, cmd, branch, range, commit, _commit$split3, _commit$split4, name, email, message;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return Version.getIncrement();

              case 2:
                increment = _context3.sent;
                cmd = "npm version " + increment + " -m \"Automated Release: v%s\n\n[ci skip]\"";
                branch = Version.getBranch();


                debug.info("Bumping v" + this.pkg.version + " with " + increment + " release...");

                if (!this.options.dryRun) {
                  _context3.next = 8;
                  break;
                }

                return _context3.abrupt("return", debug.warn("[DRY RUN] " + cmd));

              case 8:
                if (!process.env.CI) {
                  _context3.next = 22;
                  break;
                }

                range = Version.getCommitRange();
                commit = Version.exec("git log -n1 --format='%an|%ae|%s' " + range).shift();

                if (commit) {
                  _context3.next = 13;
                  break;
                }

                throw new Error("No commits found in " + range);

              case 13:
                _commit$split3 = commit.split("|");
                _commit$split4 = (0, _slicedToArray3.default)(_commit$split3, 3);
                name = _commit$split4[0];
                email = _commit$split4[1];
                message = _commit$split4[2];


                debug.info("Overriding user.name to " + name);
                Version.exec("git config user.name \"" + name + "\"");

                debug.info("Overriding user.email to " + email);
                Version.exec("git config user.email \"" + email + "\"");

              case 22:

                Version.exec("git checkout " + branch);
                Version.exec(cmd);

              case 24:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function increment() {
        return ref.apply(this, arguments);
      }

      return increment;
    }()
  }, {
    key: "publish",
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        var cmd;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                cmd = "npm publish";

                if (!this.pkg.private) {
                  _context4.next = 3;
                  break;
                }

                return _context4.abrupt("return", debug.warn("Private package! Skipping " + cmd + "..."));

              case 3:
                if (!this.options.dryRun) {
                  _context4.next = 5;
                  break;
                }

                return _context4.abrupt("return", debug.warn("[DRY RUN] " + cmd));

              case 5:

                if (process.env.CI && process.env.NPM_TOKEN) {
                  debug.info("Writing NPM_TOKEN to ~/.npmrc...");
                  Version.exec('echo "//registry.npmjs.org/:_authToken=${NPM_TOKEN}" > ~/.npmrc');
                }

                Version.exec(cmd);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function publish() {
        return ref.apply(this, arguments);
      }

      return publish;
    }()
  }, {
    key: "push",
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
        var _Version$getUserRepo2, user, repo, token, origin, cmd;

        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (process.env.CI && process.env.GH_TOKEN) {
                  _Version$getUserRepo2 = Version.getUserRepo();
                  user = _Version$getUserRepo2.user;
                  repo = _Version$getUserRepo2.repo;
                  token = '${GH_TOKEN}';
                  origin = "https://" + user + ":" + token + "@github.com/" + user + "/" + repo + ".git";


                  debug.info("Explicitly setting git origin to: " + origin);

                  Version.exec("git remote set-url origin " + origin);
                }

                cmd = "git push origin master --tags";


                if (this.options.dryRun) {
                  debug.warn("[DRY RUN] " + cmd);
                } else {
                  Version.exec(cmd, { stdio: "ignore" });
                }

              case 3:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function push() {
        return ref.apply(this, arguments);
      }

      return push;
    }()
  }, {
    key: "release",
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.increment();

              case 2:
                _context6.next = 4;
                return this.publish();

              case 4:
                _context6.next = 6;
                return this.push();

              case 6:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function release() {
        return ref.apply(this, arguments);
      }

      return release;
    }()
  }]);
  return Version;
}();

Version.defaultOptions = {
  branch: "master"
};
Version.INCREMENT_MAJOR = "major";
Version.INCREMENT_MINOR = "minor";
Version.INCREMENT_PATCH = "patch";
exports.default = Version;