#!/usr/bin/env node
"use strict";

var _meow = require("meow");

var _meow2 = _interopRequireDefault(_meow);

var _debug = require("./debug");

var _Version = require("./Version");

var _Version2 = _interopRequireDefault(_Version);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cli = (0, _meow2.default)("\n  Usage:\n    $ github-semantic-version\n\n  Options:\n    -b, --branch    (Default: master) Release branch, others are ignored.\n    -d, --dry-run   Perform dry-run without pushing or publishing.\n", {
  alias: {
    b: "branch",
    d: "debug",
    f: "force"
  },

  default: _Version2.default.defaultOptions
});

if (process.env.CI || cli.flags.dryRun || cli.flags.force) {
  new _Version2.default(cli.pkg, cli.flags).release();
} else {
  (0, _debug.error)("Not in CI environement.");
  cli.showHelp(1);
}